#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# ΂BW3DvZ

require 'dxruby'

# Sprite
class Star < Sprite
  attr_accessor :rx, :ry, :rz, :cx, :cy

  @@scrz = 200 # ʂ܂ł̋
  @@dz = -2.5 # zW̑x
  @@w = 256 # ͈̔

  # 
  def initialize(cx, cy, img)
    super
    self.cx = cx
    self.cy = cy
    self.image = img
    self.init
  end

  # W
  def init
    self.rx = rand(@@w) - (@@w / 2) # ʒuݒ
    self.ry = rand(@@w) - (@@w / 2)
    self.rz = rand(256) + 10
  end

  # t[Ă΂鏈
  def update
    # xZ
    self.rz += @@dz
    
    # ʂ̂瑤ɔяoĂW
    self.init if self.rz <= 0.0
    
    # `WZo
    px = self.rx * @@scrz / self.rz
    py = self.ry * @@scrz / self.rz
    self.x = self.cx + px - self.image.width / 2
    self.y = self.cy + py - self.image.height / 2

    if self.x < 0 or self.x > Window.width or
        self.y < 0 or self.y > Window.height
      # ʊOɔяoW⏉
      self.init
    end
  end
end


img = Image.load("star.png")

# ʒuBʂ̉Êقɐݒ
cx = Window.width * 0.75
cy = Window.height * 0.25

sprs = []
64.times do
  sprs.push(Star.new(cx, cy, img)) # 𔭐Ĕzɓo^
end

# C[v
Window.loop do
  break if Input.keyPush?(K_ESCAPE)

  Sprite.update(sprs)
  Sprite.draw(sprs)
end
